;
;	For ROM  version: Compile with standalone=0, then compile ST-ONT-Blitter-Atarimax.asm
;	For XEX  version: Compile with standalone=1, then compile ST-ONT-Blitter-DOS.asm
;	For test version: Compile without setting standlone, so it is set to standaline=2

	.if .not .def standalone
	.def standalone = 2
	.endif
	.echo "Compiling with mode standalone=",standalone,"."

	icl "ST-ONT-Equates.asm"
	icl "ST-ONT-Blitter-Music.asm"

blitter_only	= 0
max_lines	= 240
screen_lines	= 200

bcb_length	= 21
bcb_control	= 20

gradient_map_window	equ vbxe_window
xdl_window		equ vbxe_window
copy_bcb_window		equ vbxe_window+$100
copy_bcb_vram		equ $000100

clear_screen_bcb_window	equ vbxe_window+$200
clear_screen_bcb_vram	equ $000200
clear_screen_highest	equ clear_screen_bcb_window+vbxe.blitter.clear_screen_bcb.dest_adr_offset+2;^sm

calc_slope_bcb_window	equ vbxe_window+$280
calc_slope_bcb_vram	equ $000280 

copy_palette_bcb_window	equ vbxe_window+$2C0
draw_hline_bcb_window	equ vbxe_window+$300
draw_hline_bcb_vram	equ $000300

show_screen_highest	equ xdl_window+vbxe.xdl.sm_ptr_offset+2	;^sm
draw_screen_highest	equ vbxe_window+$20

polycolor		equ vbxe_window+$22

redges_window		equ vbxe_window+$3d00
redges_vram		equ $003d00
ledges_window		equ vbxe_window+$3e00
ledges_vram		equ $003e00

screen_1_vram		equ $210000
screen_2_vram		equ $220000
screen_3_vram		equ $230000
screen_4_vram		equ $240000


square1_lo	equ $c000
square1_hi	equ square1_lo+512
square2_lo	equ square1_hi+512
square2_hi	equ square2_lo+512

 ;in local fast ram
bcbstartlo	equ $c800	;:256	.byte <($0300+#*21)
bcbstarthi	equ $c900 	;:256	.byte >($0300+#*21)
bcbsendlo	equ $ca00 	;:256	.byte <($4300+#*21+20)
bcbsendhi	equ $cb00	;:256	.byte >($4300+#*21+20)	

mul32		equ $cc00
lsrf0tab	equ $cd00

palette_size	equ 48
palette		equ $cf00	;3*16 = $30 bytes

vertxs		equ $fc00 
vertys		equ $fd00 
indices		equ $fe00

;		org $80
		org $70		;Because RMZ player uses $C3..$ff
screen_counter	org *+1		;1 byte
bank_number	org *+1		;1 byte

miny		org *+1		;1 byte
maxy		org *+1		;1 byte
pointer		org *+1 	;1 byte

sx1		org *+1		;1 byte
sx2		org *+1		;1 byte
sy1		org *+1		;1 byte
sy2		org *+1		;1 byte

t1 		org *+2		;2 bytes
t2		org *+2		;2 bytes
product 	org *+4		;4 bytes

flags		org *+1		;1 byte
numframeverts	org *+1		;1 byte
polytype	org *+1		;1 byte
vert_count	org *+1		;1 byte
vert_index	org *+1		;1 byte

timer		org *+6		;6 bytes
screen_tab	org *+8 	;8 bytes
polymask	org *+2 	;2 bytes

get_byte	*	 	;to $ff

.if standalone=0 .or standalone=1
	opt f+
.else
	opt f-
.endif

;---------------------------------------------------------------

	org demo		;Called directly by DOS version, irrespective of RUNADR
	
	jmp start

;---------------------------------------------------------------

	.proc start
	jsr init
	jsr intro
	jmp main
	.endp

	.proc init

	mva #$ff COLDST		;We are the low memory area and have destroy DOS

	sei
	lda #0
	sta nmien
	sta dmactl
	sta colbk
	jsr init_stream_banks

	lda #0
	sta timer
	sta timer+1
	sta timer+2

	lda #^screen_1_vram
	sta screen_tab
	sta screen_tab+4
	lda #^screen_2_vram
	sta screen_tab+1
	sta screen_tab+5
	lda #^screen_3_vram
	sta screen_tab+2
	sta screen_tab+6
	lda #^screen_4_vram
	sta screen_tab+3
	sta screen_tab+7
	
	lda #0
@	sta palette,x
	inx
	bne @-
	
	jsr vbxe.init
			
@	lda vcount
	bne @-

	ldx #[.len get_byte_zp-1]
@	lda get_byte_rom,x
	sta get_byte,x
	dex
	bpl @-
	
 	ldx #0
@	txa
:5	asl
	sta mul32,x
	inx
	bne @-
 
@ 	txa
:4 	lsr
 	sta lsrf0tab,x
 	inx
 	bne @-
 
	lda #0
	tax
	sta pointer
	lda #>draw_hline_bcb_vram
	sta pointer+1

@	lda pointer
	sta bcbstartlo,x
	lda pointer+1
	sta bcbstarthi,x
	lda pointer
	clc
	adc #bcb_length
	sta pointer
	scc
	inc pointer+1

	inx
	bne @-
	
	lda #bcb_control
	sta pointer
	lda #>draw_hline_bcb_window
	sta pointer+1
@	lda pointer
	sta bcbsendlo,x
	lda pointer+1
	sta bcbsendhi,x
	lda pointer
	clc
	adc #bcb_length
	sta pointer
	scc
	inc pointer+1

	inx
	bne @-

	jsr multiply.generate_square_tables

	lda #^screen_1_vram	
	jsr vbxe.clear_screen
	lda #^screen_2_vram	
	jsr vbxe.clear_screen
	lda #^screen_3_vram	
	jsr vbxe.clear_screen
	lda #^screen_4_vram	
	jsr vbxe.clear_screen

	mva #1 VBXE_VIDEO_CONTROL	; enable XDL

;	jsr mpt_player.init
	lda #0
	ldx #<music
	ldy #>music
	jsr rmt_player.init
	m_init_2nd_pokey

	mwa #nmi $fffa
	mva #$c0 nmien
	mva #>charset chbase
	rts
	
	.proc init_stream_banks
.if standalone=0
	ldx #stream_bank
	stx bank_number
	sta carctl,x
	mva #$fe portb		;switch off ROM to get 16k more ram	
.elseif standalone=1
	ldx #stream_bank
	stx bank_number
	lda portb_banks,x
	and #$fe		;switch off ROM to get 16k more ram	
	sta portb
.elseif standalone=2
	mva #$fe portb		;switch off ROM to get 16k more ram	
.endif
	rts
	.endp

	.endp

	.proc intro
@	lda vcount
	bne @-

	mwa #intro_dlist dlistl
	mva #34 dmactl
	mva #4 hscrol
	mva #15 colpf0
	mva #12 colpf1
	mva #8 colpf2
	
@	lda timer+1
	cmp #$05
	bcc @-
	rts

	.endp
	
	.proc main	
@	lda vcount
	bne @-
	
	mwa #main_dlist dlistl
	mva #33 dmactl
	ldx #0
	stx timer
	stx timer+1
	stx timer+2

	.if scene_version = 1
	jsr copy_palette0	;V1, fixed palette
	.endif

main_demo_loop
	ldx screen_counter
	lda screen_tab,x		;Dhow that screen
	sta show_screen_highest

	lda screen_tab+1,x	;Draw to this screen
	sta draw_screen_highest
	.if scene_version = 2
	jsr copy_palette	;V2, dynamic palette
	.endif

;	Clear actual screen
	ldx screen_counter
	lda screen_tab+2,x
	jsr vbxe.clear_screen

	jsr parse_data
	inc screen_counter
	lda screen_counter
	and #3
	sta screen_counter
	jmp main_demo_loop
	.endp

	.proc parse_data
	.if scene_version = 2
 	jsr get_byte
	sta flags

;check for palette
	and #2
	beq no_palette
;setpalettead
	jsr set_palette_buffer0
no_palette
	lda flags
	and #4 				;is this indexed data?
	beq non_indexed_mode
	jmp indexed_mode
	.endif

	.proc non_indexed_mode
do_polys2
	jsr get_byte
	sta polytype
	tax
	lda lsrf0tab,x
	ldy #$80
	sty VBXE_MEMAC_B_CONTROL
	sta polycolor
	lda #0
	sta VBXE_MEMAC_B_CONTROL
	txa
	and #$0f
	sta vert_count

	txa
	.if scene_version = 1
	cmp #$fe ;end of frame V1
	.elseif scene_version = 2
	cmp #$ff ;end of frame V2
	.endif

	bne @+
	rts
@
	.if scene_version = 1
	cmp #$ff ;end of file V1
	.elseif scene_version = 2
	cmp #$fd ;end of file V2
	.endif
	bne @+
	mwa #stream_end get_byte_zp.ptr
	mva #stream_bank-1 bank_number ;1 due to auto inc!!! 
	mwa #nmi.time_panel.flash nmi.stop+1
	rts
@
	cmp #$fe ;end of 64k
	bne @+
	mwa #stream_end get_byte_zp.ptr
	rts
@
	mva #1 maxy
	mva #screen_lines miny

	ldx vert_count
	jsr get_byte
	sta vertxs,x
	sta vertxs
	jsr get_byte
	sta vertys,x
	sta vertys
	
	ldx #1
do_verts2
	jsr get_byte
	sta vertxs,x
	jsr get_byte
	sta vertys,x
	inx
	cpx vert_count
	bne do_verts2

	lda #0
	sta do_verts3+1
;draw poly
do_verts3 ldx #0
	lda vertxs,x
	sta sx1 ;x1+1
	lda vertys,x
	sta sy1 ;y1+1
	cmp miny
	bcs @+
	sta miny
@
	cmp maxy
	bcc @+
	sta maxy
@
	lda vertxs+1,x
	sta sx2 ;x2+1
	lda vertys+1,x
	sta sy2 ;y2+1
	jsr calc_slope
	inc do_verts3+1
	dec vert_count
	bne do_verts3
	jsr draw_poly			;render_scene
	jmp do_polys2 
	.endp

	.proc indexed_mode
	jsr get_byte
	sta numframeverts		;how many vertices per frame
	ldy #0				;now read the verticesx and verticesy
@	jsr get_byte
	sta vertxs,y
	jsr get_byte
	sta vertys,y
	iny
	cpy numframeverts
	bne @-
	
do_polys
	jsr get_byte
	sta polytype
	tax
	lda lsrf0tab,x
	sta polycolor
	txa
	and #$0f
	sta vert_count ;how many lines 0-15

	lda polytype
	cmp #$ff ;end of frame
	sne
	rts

	cmp #$fd ;end of file wrap
	bne @+
	mwa #stream_end get_byte_zp.ptr
	mva #stream_bank-1 bank_number ;1 due to auto inc!!! 
	mwa #nmi.time_panel.flash nmi.stop+1
	rts
@
	cmp #$fe ;end of 64k
	bne @+
	mwa #stream_end get_byte_zp.ptr
	rts
@
	mva #1 maxy
	mva #screen_lines miny

	jsr get_byte			;first id
	ldx vert_count
	sta indices,x
	sta indices

	ldx #1
@
	jsr get_byte
	sta indices,x
	inx
	cpx vert_count
	bne @-
	
	lda #0
	sta vert_index
do_verts ;draw poly
	ldx vert_index
	ldy indices,x
	lda vertxs,y
	sta sx1 ;x1+1
	lda vertys,y
	sta sy1 ;y1+1
	cmp miny
	bcs @+
	sta miny
@
	cmp maxy
	bcc @+
	sta maxy
@

	ldy indices+1,x
	lda vertxs,y
	sta sx2 ;x2+1
	lda vertys,y
	sta sy2 ;y2+1

	jsr calc_slope		;poly ;_dda ;line x1,y1 to x2,y2

	inc vert_index
	lda vert_index
	cmp vert_count
	bne do_verts

	jsr draw_poly
	jmp do_polys
	.endp

	.proc set_palette_buffer0	;set palette buffer 0
	jsr get_byte 
	sta polymask 			;read short... ;)
	tay
	jsr get_byte
	sta polymask+1 			;each bit in palmask defines if color needs to be set

	.macro m_setpal register buffer
	jsr get_byte ;xx xx xx xx xx R2 R1 R0  xx G2 G1 G0 xx B2 B1 B0
	and #7
	sta palette+:register+:buffer*palette_size ;R
	jsr get_byte ;lo
	tax
	and #$70
	lsr
	lsr
	lsr
	lsr
	sta palette+16+:register+:buffer*palette_size ;G
	txa
	and #$07
	sta palette+32+:register+:buffer*palette_size ;B
	.endm

	tya
	and #128
	beq @+
	m_setpal 0 0
@	
	tya
	and #64
	beq @+
	m_setpal 1 0
@	
	tya
	and #32
	beq @+
	m_setpal 2 0
@	
	tya
	and #16
	beq @+
	m_setpal 3 0
@	
	tya
	and #8
	beq @+
	m_setpal 4 0
@	
	tya
	and #4
	beq @+
	m_setpal 5 0
@	
	tya
	and #2
	beq @+
	m_setpal 6 0
@	
	tya
	and #1
	beq @+
	m_setpal 7 0

@	
	lda polymask+1
	tay	
	and #128
	beq @+
	m_setpal 8 0
@	
	tya
	and #64
	beq @+
	m_setpal 9 0
@	
	tya
	and #32
	beq @+
	m_setpal 10 0
@	
	tya
	and #16
	beq @+
	m_setpal 11 0
@	
	tya
	and #8
	beq @+
	m_setpal 12 0
@	
	tya
	and #4
	beq @+
	m_setpal 13 0
@	
	tya
	and #2
	beq @+
	m_setpal 14 0
@	
	tya
	and #1
	beq @+
	m_setpal 15 0
@	rts
	.endp
	
	.endp		;end of parse


	.if scene_version = 1
	.proc copy_palette0
	ldx #0
	ldy #0
@
	stx VBXE_CSEL
	lda st_palette,y
	asl
	asl
	asl
	asl
	asl
	sta VBXE_CR
	lda st_palette+1,y
	asl
	asl
	asl
	asl
	asl
	sta VBXE_CG
	lda st_palette+2,y
	asl
	asl
	asl
	asl
	asl
	sta VBXE_CB
	iny
	iny
	iny
	inx
	cpx #16
	bne @-
	rts
	.endp
	.endif

	.if scene_version = 2
	.proc copy_palette
;	[10:46:28] axis/oxyron (oxy): just copy pal
;	[10:46:32] axis/oxyron (oxy): once per frame
;	[10:46:38] axis/oxyron (oxy): pal1, pal2, pal3
;	[10:47:03] Karolj Nadj: yeah but... pal2 contains only delta colors to pal1
;	[10:47:19] axis/oxyron (oxy): you always build pal1 out of the deltas
;	[10:47:23] axis/oxyron (oxy): copy 1 to 2
;	[10:47:25] axis/oxyron (oxy): copy 2 to 3
;	[10:47:25] axis/oxyron (oxy): copy 3 to 4
				
;	[10:47:28] axis/oxyron (oxy): and use 4 for rendering
;	[10:47:35] axis/oxyron (oxy): e.g.

	ldx #15
@
	stx VBXE_CSEL
	ldy palette+0*palette_size,x
	lda mul32,y
	sta VBXE_CR
	ldy palette+16+0*palette_size,x
	lda mul32,y
	sta VBXE_CG
	ldy palette+32+0*palette_size,x
	lda mul32,y
	sta VBXE_CB
	dex
	bpl @-
	rts
	.endp
	.endif

	.proc draw_poly	
;	sanity check
;	debug spanlength calc
@	lda VBXE_BLITTER_BUSY
	bne @-

	lda #8
	sta $cfff
cont_adr = *-2

.if blitter_only=0
	ldy miny
@
	lda redges_window,y 
	sec
	sbc ledges_window,y
	bcs sk
	lda #0
sk
	sta redges_window,y
	iny
	cpy maxy
	bcc @-
.endif

;	add+EOR#$ff = sub = spanlength
;	fill in tables into scanedge blittlist

	lda #<copy_bcb_vram
	sta VBXE_BL_ADR0
	lda #>copy_bcb_vram
	sta VBXE_BL_ADR1
	lda #^copy_bcb_vram
	sta VBXE_BL_ADR2
	inc VBXE_BLITTER_START
	
;	Blit poly_face	
	ldy maxy
	dey
	lda bcbsendlo,y
	sta cont_adr
	sta stop_adr
	lda bcbsendhi,y
	sta cont_adr+1
	sta stop_adr+1

	lda #0 ;stop flag
	sta $ffff
stop_adr = *-2

@	lda VBXE_BLITTER_BUSY
	bne @-

	sta VBXE_BL_ADR2
	ldy miny
	mva bcbstartlo,y VBXE_BL_ADR0
	mva bcbstarthi,y VBXE_BL_ADR1

	inc VBXE_BLITTER_START	 ;blit face
	rts
	.endp

;---------------------------------------------------------------

	.proc multiply

	.proc generate_square_tables	; generate f(x)=int(x*x/4)
	ldx #$00
	txa
	.byte $c9			;CMP #imm to skip first tya
lb1	tya
	adc #$00
ml1	sta square1_hi,x
	tay
	cmp #$40
	txa
	ror 
ml9	adc #$00
	sta ml9+1
	inx
ml0	sta square1_lo,x
	bne lb1
	inc ml0+2
	inc ml1+2
	clc
	iny
	bne lb1

	ldx #$00			; generate f(x)=int((x-255)*(x-255)/4)
	
	ldy #$ff
ml2	lda square1_hi+1,x
	sta square2_hi+$100,x
	lda square1_hi,x
	sta square2_hi,y
	lda square1_lo+1,x
	sta square2_lo+$100,x
	lda square1_lo,x
	sta square2_lo,y
	dey
	inx
	bne ml2
	rts
	.endp	

	.proc multiply_16x8bit_unsigned

;	<T1 * <T2 = AAaa
;	>T1 * <T2 = CCcc
;
;	      AAaa
;	+   CCcc
;	----------
;	PRODUCT!
		
;	Setup T1 if changed
	bcc m16x8u_setup_done
	lda T1+0
	sta sm1a16x8+1
	sta sm3a16x8+1
	eor #$ff
	sta sm2a16x8+1
	sta sm4a16x8+1
	lda T1+1
	sta sm1b16x8+1
	sta sm3b16x8+1
	eor #$ff
	sta sm2b16x8+1
	sta sm4b16x8+1
m16x8u_setup_done

		; Perform <T1 * <T2 = AAaa
		ldx T2+0
		sec
sm1a16x8	lda square1_lo,x
sm2a16x8	sbc square2_lo,x
		sta product+0
sm3a16x8	lda square1_hi,x
sm4a16x8	sbc square2_hi,x
		sta _AA16x8+1

		; Perform >T1_hi * <T2 = CCcc
		sec
sm1b16x8	lda square1_lo,x
sm2b16x8	sbc square2_lo,x
		sta _cc16x8+1
sm3b16x8	lda square1_hi,x
sm4b16x8	sbc square2_hi,x
		sta product+2

		; Add the separate multiplications together
	clc
_AA16x8	lda #0
_cc16x8	adc #0
	sta product+1
	scc
	inc product+2

	rts
	.endp
	
	.endp		;end of multiply

fastexit rts

	.proc calc_slope
	lda VBXE_BLITTER_BUSY		;wait blitter
	bne calc_slope
	lda #>ledges_vram		;left edge buffer 
	sta calc_slope_bcb_window+7

	lda sy2
	cmp sy1 
	beq fastexit
	bcs no_swap 			;swap needed?
	ldx sx1
	lda sx2
	sta sx1
	stx sx2
	ldx sy1
	lda sy2
	sta sy1
	stx sy2
	lda #>redges_vram	 	;right edge buffer 
	sta calc_slope_bcb_window+7
no_swap
	lda sx1
	cmp sx2
	bcs signed_version ;>=

	.proc unsigned_version
	lda sx1
	sta calc_slope_bcb_window+1	;start x value of edge = startpos in array (*256 as 8.8 format)
	ldx sy1				;table entry point is at sy1
	stx calc_slope_bcb_window+6	;low byte of edge table starting at sy1 = fill array at sy1 to sy2	

	mwa #$0001 calc_slope_bcb_window+9

	lda sx2 
	sec
	sbc sx1
	sta t2
	jmp continue
	.endp

	.proc signed_version
	lda sx2
	sta calc_slope_bcb_window+1	;start x value of edge = startpos in array (*256 as 8.8 format)
	lda sy2				;table entry point is at sy2
	sec
	sbc #1
	sta calc_slope_bcb_window+6 	;low byte of edge table starting at sy1 = fill array at sy2 to sy1	

	mwa #$ffff calc_slope_bcb_window+9

	lda sx1 
	sec
	sbc sx2
	sta t2
	.endp

continue

;	##TRACE "sx1= %02x sx2= %02x sx1-sx2= %04x" db(sx1) db(sx2) dw(t1)

	lda sy2
	sec
	sbc sy1 
	tax
	lda recitab32768,x
	sta t1
	lda recitab32768+256,x
	sta t1+1
	dex
	stx calc_slope_bcb_window+14 		;edge length = blit size y

	sec
	jsr multiply.multiply_16x8bit_unsigned	;dx/dy = dx * 1/dy

;	blitprep 
;	check if slope>+$1000 then slope=+$1000
;	check if slope>-$1000 then slope=-$1000 = $1fff	
;	$f000 = -4096 ;in blitter 12bit step (13bits!!!)
;	$f001 = -4095
;	$ffff = -1
;	$0001 = +1
;	$0fff = +4095

	mwa product+1 calc_slope_bcb_window+3

	lda product+2
	cmp #$0f
	bcc no_limit
	mwa #$0fff calc_slope_bcb_window+3
no_limit

	mva #<calc_slope_bcb_vram VBXE_BL_ADR0	; set blitter addr
	mva #>calc_slope_bcb_vram VBXE_BL_ADR1
	mva #^calc_slope_bcb_vram VBXE_BL_ADR2
    	inc VBXE_BLITTER_START			; start blitter (LERP)
	rts
	.endp


;---------------------------------------------------------------
	.if scene_version = 1
	.local st_palette
;ST:	xx xx xx xx xx R2 R1 R0  xx G2 G1 G0 xx B2 B1 B0
;SNES:	0BBBBBGG GGGRRRRR
;VBXE:	RRRRRRRR,GGGGGGGG,BBBBBBBB

;	dc.w	$000	;0x00,0x00,0x00
;	.byte $00,$00
	.byte $00,$00,$00
;	dc.w	$0111	;0x08,0x08,0x08
;	.byte $01,$11
	.byte $01,$01,$01
;	dc.w	$0012	;0x20,0x10,0x08
;	.byte $01,$02
	.byte $00,$10,$02
;	dc.w	$0201	;0x10,0x08,0x20
;	.byte $02,$01
	.byte $02,$00,$01
;	dc.w	$0112	;0x20,0x18,0x18
;	.byte $01,$12
	.byte $01,$01,$02
;	dc.w	$0212	;0x20,0x18,0x20
;	.byte $02,$12
	.byte $02,$01,$02
;	dc.w	$0223	;0x31,0x20,0x20
;	.byte $02,$23
	.byte $02,$02,$03
;	dc.w	$0322	;0x20,0x20,0x39
;	.byte $03,$22
	.byte $03,$02,$02
;	dc.w	$0422	;0x20,0x20,0x41
;	.byte $04,$22
	.byte $04,$02,$02
;	dc.w	$0224	;0x4A,0x29,0x20
;	.byte $02,$24
	.byte $02,$02,$04
;	dc.w	$0136	;0x6A,0x39,0x18
;	.byte $01,$36
	.byte $01,$03,$06
;	dc.w	$0532	;0x20,0x31,0x5A
;	.byte $05,$32
	.byte $05,$03,$02
;	dc.w	$0434	;0x4A,0x39,0x4A
;	.byte $04,$34
	.byte $04,$03,$04
;	dc.w	$0545	;0x5A,0x41,0x5A
;	.byte $05,$45
	.byte $05,$04,$05
;	dc.w	$0741	;0x18,0x4A,0x8B
;	.byte $07,$41
	.byte $07,$04,$01
;	dc.w	$777	;0xFF,0xFF,0xFF
; 	.byte $07,$77
	.byte $07,$07,$07
	.endl
	.endif

	.local intro_dlist
	space = $20
	.byte $70,$70,$70
	.byte $47, a(intro_text),space
	.byte 7,$60
	.byte 9,$60
	.byte 7,space
	.byte $17,$50
	.byte 9,$60
	.byte 7,space
	.byte 7,space
	.byte 7,$60
	.byte $17
	.byte $41, a(intro_dlist)
	.endl
	m_info intro_dlist

	.local intro_text
	.sb +64 '   DESIRE PRESENT   '
	.sb +64 " NEW COMPO FOR YOU! "
:10	.byte $ff
	.byte d"   NOSTALGIC TRIP   "
	.byte d"  WHO RENDERS FASTER?   "
:10	.byte $ff
	.sb +64 "WE USE 1:1 ST DATA! "
	.sb +64 "     MORE INFO      "
	.sb +64 " WWW.ARSANTICA.COM  "
	.sb +128 "  VBXE FOUND AT $D",$30+((VBXE_BASE/256)&$0f),"00   "
	.endl
	
	.print "Main code before music at ", music, " ends at ",*-1

	org music
	ins "ST-ONT-Music.dat"

	.if *<>$3800
	.error "Music ends at ",*-1," instead of ",$37ff
	.endif

	m_align_2_pages
	.local recitab32768
	ins "ST-ONT-ReciTab65536.dat"
	.endl

	m_align_2_pages
	.local charset
	ins "Antic.chr",0,512
	.endl

	.local main_dlist
	.byte $60
	.byte $80			;DLI for music
:25	.byte $70
	.byte $c6, a(main_text)		;DLI for music
	.byte $41, a(main_dlist)
	.endl

	m_info main_dlist

	.local main_text
 	dta d"    00:00:00     "
 	.endl

;---------------------------------------------------------------

.proc	nmi
	bit nmist
	bpl vbi

	pha
	txa
	pha
	tya
	pha

	jsr rmt_player.play
	m_update_2nd_pokey

	pla
	tay
	pla
	tax
	pla
	rti
   
vbi	sta nmires

	sta vbl_a+1
	stx vbl_x+1
	sty vbl_y+1
	cld

;	jsr mpt_player.play

stop	jsr time_panel.increment	

vbl_a	lda #0
vbl_x	ldx #0
vbl_y	ldy #0

nmi_end	rti

	.proc time_panel

	.proc increment	
	sed				;BCD mode on
	lda timer
	clc
	adc #2				;1/50s = 2/100s
	sta timer
	lda timer+1
	adc #0
	sta timer+1
	cmp #$60
	bcc @+
	lda #0
	sta timer+1
	lda timer+2
	adc #0
	sta timer+2
	cmp #$60
	bcc @+
	lda #0
	sta timer+2	
@	cld				;BCD mode off

	lda timer
	and #$0f
	tax
	lda digits,x
	sta main_text+11
	lda timer
	lsr
	lsr
	lsr
	lsr
	tax
	lda digits,x
	sta main_text+10
	lda timer+1
	and #$0f
	tax
	lda digits,x
	sta main_text+8
	lda timer+1
	lsr
	lsr
	lsr
	lsr
	tax
	lda digits,x
	sta main_text+7
	lda timer+2
	and #$0f
	tax
	lda digits,x
	sta main_text+5
	lda timer+2
	lsr
	lsr
	lsr
	lsr
	tax
	lda digits,x
	sta main_text+4
	rts

digits 	dta d"0123456789"

	.endp

	.proc flash
	inc color
	lda #0
color = *-1
	and #$0f
	sta colpf0
	rts

	.endp
	
	.endp		;end of time_panel

	.endp		;end of nmi

;---------------------------------------------------------------

	.proc vbxe


	.local xdl
sm_ptr_offset = sm_ptr-xdl	;3 bytes
	.byte $72		;repeat+adr+gfx
	.byte $88		;stop
	.byte 199		;RPTL
sm_ptr	.long screen_1_vram	;OVADR / vramadr
	.word $0100		;ystep of display	  
	.byte $10,$c0		;OVATT
	.endl
	m_info xdl

	.local blitter

	.local copy_bcb		;copies edge into bcb
;polycolor_offset = polycolor-*

;vram adress for double buffer
	.long $000020 ;source
	.word 0		;source step y
	.byte 0		;source step x
	.long $000308	;destination adress
	.word 21	;dest. step y
	.byte 0		;dest. step x
	.word 0		;size x
	.byte 199	;size y
	.byte $ff 	;and
	.byte $0	;XOR
	.byte 0		;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 8		;control

;polycolor
	.long $000022	;source color right edge 
	.word 0		;source step y
	.byte 0		;source step x
	.long $000310	;destination adress
	.word 0		;dest. step y
	.byte 21	;dest. step x
	.word 199	;size x
	.byte 0		;size y
	.byte $ff 	;and
	.byte $00 	;XOR
	.byte 0	 	;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 8		;control

	.long ledges_vram	;source adress left edge
	.word 0			;source step y
	.byte 1			;source step x
	.long $000306		;destination adress
	.word 0			;dest. step y
	.byte 21		;dest. step x
	.word max_lines-1	;size x
	.byte 0			;size y
	.byte $ff 		;and
	.byte $00		;XOR
	.byte 0			;collision AND
	.byte $00		;zoom
	.byte 0			;pattern
	.byte 8			;control

.if blitter_only=1
;spanlength = left AND #$ff EOR #$ff+right into right+1
	.long ledges_vram ;source 
	.word 1		;source step y
	.byte 0 	;source step x
	.long redges_vram	;destination adress
	.word 1 	;dest. step y
	.byte 0		;dest. step x
	.word 0		;size x
	.byte 199	;size y
	.byte $ff 	;and
	.byte $ff	;XOR
	.byte 0		;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 10	;control

	.long $000000	;source
	.word 0		;source step y
	.byte 0		;source step x
	.long redges_vram ;destination adress
	.word 1		;dest. step y
	.byte 0		;dest. step x
	.word 0		;size x
	.byte 199	;size y
	.byte $00 	;and
	.byte $01	;XOR
	.byte 0		;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 10	;control
.endif

;spanlength
	.long redges_vram ;source length edge
	.word 0		;source step y
	.byte 1		;source step x
	.long $00030c	;destination adress
	.word 0		;dest. step y
	.byte 21	;dest. step x
	.word 199	;size x
	.byte 0		;size y
	.byte $ff 	;and
	.byte $00	;XOR
	.byte 0		;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 0		;control

	.long $003c00 ;source color start
	.word 0		;source step y
	.byte 1		;source step x
	.long $000301	;destination adress
	.word 0		;dest. step y
	.byte 21	;dest. step x
	.word 199	;size x
	.byte 0		;size y
	.byte $ff 	;and
	.byte $00	;XOR
	.byte 0		;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 8		;control

;stepy value
	.long $003a00	;source step value
	.word 0		;source step y
	.byte 1		;source step x
	.long $000303	;destination adress
	.word 21	;dest. step y
	.byte 1		;dest. step x
	.word 2-1	;size x
	.byte 199	;size y
	.byte $ff 	;and
	.byte $00	;XOR
	.byte 0		;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 0		;control
	.endl

	.local copy_palette_bcb	;copy palette 0,30,60,90,c0
	.long palette+4*palette_size-vbxe_window ;$003f90 ;source
	.word -palette_size	;source step y
	.byte 1			;source step x
	.long palette+5*palette_size-vbxe_window ;$003fc0 ;destination adress
	.word -palette_size	;dest. step y
	.byte 1			;dest. step x
	.word palette_size-1	;size x
	.byte 4			;size y
	.byte $ff 		;and
	.byte $00		;XOR
	.byte 0			;collision AND
	.byte $00		;zoom
	.byte 0			;pattern
	.byte 0			;control
	.endl

	.local clear_screen_bcb
dest_adr_offset = dest_adr-*
	.long $000000	;source adress
	.word 0 	;source step y
	.byte 0		;source step x
dest_adr
	.long $040000	;destination adress
	.word 256	;dest. step y
	.byte 1
	.word 255	;size x
	.byte 199	;size y
	.byte $00 	;and
	.byte $00	;XOR
	.byte 0		;collision AND
	.byte $00	;zoom
	.byte $00	;pattern
	.byte 0		;control

	.endl

	.local calc_slope_bcb
	.long $070000	;source length edge
	.word $0000	;source step y = m
	.byte 0		;source step x
	.long redges_vram	;right edge or left
	.word 1		;dest. step y
	.byte 0		;dest. step x
	.word 0		;size x ;only 1 byte copy
	.byte 199	;size y
	.byte $ff 	;and
	.byte $00	;XOR
	.byte 0		;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 0		;control
	.endl

	.local draw_hline_bcb
	.long $074000	;source adress
	.word 0		;source step y
	.byte 0		;source step x
	.long $010000+0*256 ;destination adress
	.word 0		;0 ;dest. step y
	.byte 1		;-1
	.word 0		;size x
	.byte 0		;size y
	.byte $00 	;and
	.byte $ff	;XOR
	.byte 0	 	;collision AND
	.byte $00	;zoom
	.byte 0		;pattern
	.byte 8		;control
	.endl

	.endl		;end of blitter

	.proc init
	sta $d080			;Reset VBXE
	ldx #1
	stx VBXE_PSEL

	ldx #0				;Set color 0 to black
	stx VBXE_CSEL
	stx VBXE_CR
	stx VBXE_CG
	stx VBXE_CB

	stx VBXE_XDL_ADR0
	stx VBXE_XDL_ADR1
	stx VBXE_XDL_ADR2
	stx VBXE_CG			;Disable collision detection
	stx VBXE_IRQ_CONTROL		;Disable IRQ

	mva #>vbxe_window|$0e VBXE_MEMAC_CONTROL	;16k bank at $4000/$8000 with CPU and ANTIC access
	jsr init_gradient_map
	jsr init_xdl_and_blitter	;Activates bank 0 for the rest of the demo
	rts

;	The 64k table in VRAM is a count table for the blitter.
;	The MULS are only for the setop of the slope, but the blitter interpolates
;	And because it does not have a fractional parts, I'm using an 8.8 table
;	The blitter run through that table, which makes it all so fast

	.proc init_gradient_map		;Generate 4*16k=64k tables at $70000-$7ffff in VRAM
	ldy #$00			;For y=$00 to $ff
bank_loop
	lda #$f0
bank_number = *-1
	sta VBXE_MEMAC_BANK_SEL
	clc
	adc #4
	sta bank_number

	ldx #0
loop	tya
	sta gradient_map_window,x
address = *-2
	inx 
	bne loop
	inc address+1
	iny
	tya
	and #$3f
	bne loop
	mva #>gradient_map_window address+1
	cpy #0
	bne bank_loop
	rts

	.endp

	.proc init_xdl_and_blitter
	mva #$80 VBXE_MEMAC_BANK_SEL

	ldx #.len xdl-1
@	lda xdl,x
	sta xdl_window,x		;Copy XDL to VRAM
	dex
	bpl @-

	ldx #0
@	lda blitter.copy_bcb,x
	sta copy_bcb_window,x
	inx
	cpx #.len blitter.copy_bcb
	bne @-

	ldx #0
@	lda blitter.clear_screen_bcb,x
	sta clear_screen_bcb_window,x
	inx
	cpx #.len blitter.clear_screen_bcb
	bne @-

	ldx #0
@	lda blitter.calc_slope_bcb,x
	sta calc_slope_bcb_window,x
	inx
	cpx #.len blitter.calc_slope_bcb
	bne @-
	
	ldx #0
@	lda blitter.copy_palette_bcb,x
	sta copy_palette_bcb_window,x
	inx
	cpx #.len blitter.copy_palette_bcb
	bne @-
	

	.proc init_draw_hline
	ldy #0	
loop	ldx #bcb_length-1
	sty blitter.draw_hline_bcb+7
@	lda blitter.draw_hline_bcb,x
bcbad	sta draw_hline_bcb_window,x
	dex
	bpl @-
	lda bcbad+1
	clc
	adc #bcb_length
	sta bcbad+1
	scc
	inc bcbad+2
	
	iny
	cpy #max_lines
	bne loop

	lda #0			;Write stop mark to blitlist
	sta draw_hline_bcb_window+bcb_control+[max_lines-1]*bcb_length
	.endp

	rts
	.endp

	.endp	

	.proc waitblt			;wait until not-busy
	lda VBXE_BLITTER_BUSY
	bne waitblt
	rts
	.endp

	.proc clear_screen		;IN: <A>=screen highest byte
	pha
	jsr waitblt
	mva #<clear_screen_bcb_vram VBXE_BL_ADR0
	mva #>clear_screen_bcb_vram VBXE_BL_ADR1
	mva #^clear_screen_bcb_vram VBXE_BL_ADR2
	pla
	sta clear_screen_highest	;Set highest byte of screen to clear
	inc VBXE_BLITTER_START
	rts
	.endp

	.endp			;end of vbxe

	m_info	vbxe
;---------------------------------------------------------------

get_byte_rom
	.proc get_byte_zp,get_byte
	lda ptr+1
	cmp #>stream_end
	bne same_bank
	mwa #stream_data ptr
	inc bank_number

	.if standalone=0
	lda bank_number
	sta bank_register		;Change low byte of next instruction
	sta carctl			;Simulates carctl,x without using X
bank_register = *-2
	.elseif standalone=1
	stx save_x
	ldx bank_number
	lda portb_banks,x
	and #$fe
	sta portb
	ldx #0
save_x = *-1
	.elseif standalone=2		;No code in case we run in standlone test mode

	.endif

same_bank
	lda stream_data
ptr	= *-2
	inw ptr
	rts
	.if *>$100
	.error "No more in zero page at ",*,"."
	.endif

	.endp
	m_info get_byte_zp

	.if *>$4000
	.error "Code ends at ",*-1," instead of before ",$4000
	.endif

	.if standalone=2
	org $4000
	m_ins 0*$4000,$4000

	run demo
	.endif
